<?php
/**
 * Encoding CP1251
 *  - th-net at ya.ru
 * Web-     CommFort v.2.0
 *        Web-      .   " ".
 * http://www.commfort.com/ru/forum/viewtopic.php?f=11&t=5146     .
 */
//   
$rows_per_page = 10000; //      
$logdir = 'c:/serv/commfort_server4/logs/'; //  
$show_id = true; //  true    ID 
$highlight_bg = true; // true -    ; false -    

$log_events = array( //    
    -100 => array('name' => '', 'color' => 'green'),
    10 => array('name' => ' ', 'color' => 'lightgreen'),
    11 => array('name' => ' ', 'color' => 'navy'),
    12 => array('name' => ' ', 'color' => 'green'),
    13 => array('name' => '', 'color' => 'red'),
    14 => array('name' => '', 'color' => 'magenta'),
    15 => array('name' => ' ', 'color' => 'lightblue'),
    16 => array('name' => '  ', 'color' => 'blue'),
    17 => array('name' => ' ', 'color' => 'cyan'),
    18 => array('name' => ' ', 'color' => 'lightblue'),
    19 => array('name' => ' ', 'color' => 'brown'),
    20 => array('name' => ' ', 'color' => 'gray'),
    
    22 => array('name' => ' ', 'color' => 'lightblue'),
    23 => array('name' => '', 'color' => 'red'),
    24 => array('name' => '', 'color' => 'lime'),
    
    
    27 => array('name' => '', 'color' => 'orange'),

    29 => array('name' => '  ', 'color' => 'brown'),
);

//    .

function grab_title($logfile){
    preg_match('/(?:Events|Authorisation|System)_?([0-9_]*)\./i',$logfile,$matches);
    return $matches[1]?$matches[1]:'';
}

?>
<html><head>
<style>
body{background-color:white}
a.current{background-color:yellow}
table.content{width:100%;border:solid thin black;border-collapse:collapse;}
table.content th {border:solid thin green}
table.content td {border:solid white;border-width:1px 0;padding: 2 5px;}
.err_message{border-radius: 10px; border: solid thin red;padding: 0px 5px; width: 500px; text-align: center; margin: 0px auto 5px}

</style>
<script>
function go(to){
	window.location = '?logfile='+to;
}
</script>
</head>
<body>
<?php

$events = array(
);


$sys_logs = glob($logdir."System*");
$event_logs = glob($logdir."Events/Events*");
$auth_logs = glob($logdir."Authorisation/Authorisation*");
$logfile_id = 'event_'.(count($event_logs)-1);
if (!empty($_GET['logfile'])){
    $logfile_id = $_GET['logfile'];
}

?>
 : <select onChange="go(this.value);"><option disabled="disabled"></option>
<?php
foreach ($sys_logs as $key => $logfile){
    printf('<option value="sys_%d" %s>%s</option>',$key,(($logfile_id=='sys_'.$key)?'selected="selected"':''),grab_title($logfile));
}
?>
</select> :  <select onChange="go(this.value);"><option disabled="disabled"></option>
    <?php foreach ($event_logs as $key => $logfile){
        printf('<option value="event_%d" %s>%s</option>',$key,(($logfile_id=='event_'.$key)?'selected="selected"':''),grab_title($logfile));
    }?>
</select>: <select onChange="go(this.value);"><option disabled="disabled"></option>
    <?php foreach ($auth_logs as $key => $logfile){
        printf('<option value="auth_%d" %s>%s</option>',$key,(($logfile_id=='auth_'.$key)?'selected="selected"':''),grab_title($logfile));
    }?>
</select>
<br /> : 
<?php
$logtype = substr($logfile_id,0,(strpos($logfile_id,'_'))).'_logs'; //   
$delta = substr($logfile_id,strrpos($logfile_id,'_')+1); //   
$err_messsage = '';
if (empty(${$logtype})){
    $logtype = 'event_logs';
    $err_messsage .= '    .   .<br>';  
}

if (count(${$logtype}) <= $delta){
    $delta = count(${$logtype})-1;
    $err_messsage .= '   .   .<br>';
}

$log = file(${$logtype}[$delta]);
$k = 0;
if (isset($_GET['page'])){
	$curpage = (int) $_GET['page'];
} else {
	$curpage = 1;
}

for ($p = 0;$p < count($log)/$rows_per_page;$p++){
	if($p+1 == $curpage) $page_class="class='current'"; else $page_class='';
	printf("<a href=?logfile=%s&page=%d %s>%d</a> | ",$logfile_id,$p+1,$page_class,$p+1);
}
?>
<?php if (!empty($err_messsage)){?>
    <div class="err_message"><?=$err_messsage?></div>
<?php }?>

<table class="content"><tr class="header"><th></th><th></th><th>.</th><th>IP/ID</th><th></th></tr>
<?php
if (isset($_GET['page'])){
	$i = ($curpage-1) * $rows_per_page;
}

foreach ($log as $row){

    $matches = array();
    $patterns = array(
        ' ',' ','  ',
        ' ', '   ','    ',
        '  ','    ',' ,  ',
        '  ','   ',' ','   ',
        '   :','    :','   :'
    );
	
	if ($ii++ < $i) continue;
	if ($logtype == 'auth_logs'){
	    preg_match('/(\s)?(.*)\s-\s(.*)\|(.*)\|([0-9.]*)\|([0-9a-f]*)/i',$row,$matches);
	    $matches[1] = -100;
	} else {
        preg_match('/^E([0-9]{2})\s\[([0-9.]{10})\s-\s([0-9.\:]{9,12})\]\s(?:(.*)\s)?\((?:IP\s=\s)?((?:[0-9.]*)|(?:N\/A))(?:,\sClientID\s=\s([0-9a-f]*))?\)\:\s(.*)$/iU',$row,$matches);
        //      event^^^^^^^^^^^  ^^date^^^^^time^^ ^user^
	}
	//var_dump($matches);die;
    setlocale(LC_TIME, "rus");
    $date = strftime('<nobr>%d %a %H:%M:%S</nobr>',strtotime($matches[2]." ".$matches[3]));
    $events[$matches[1]]++;
    $comment = preg_replace('/('.implode('|',$patterns).')(.*)/','\1 <b><u>\2</u></b>',$matches[7]);

    printf("<tr class='data' style='%scolor: %s;'><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n",
        ($highlight_bg?'background-':''),
        (isset($log_events[$matches[1]])?$log_events[$matches[1]]['color']:'inherit'),
        (isset($log_events[$matches[1]])?$log_events[$matches[1]]['name']:' '.$matches[1]),
        $date,
        htmlspecialchars($matches[4]),
        '<b>'.($matches[5]=='N/A'?' ?':$matches[5]).'</b>'.(($show_id&&$matches[6])?' ('.$matches[6].')':''),
        $comment
    );
        
    if (++$j == $rows_per_page) break;
}
?>
<div> : 
<?php
ksort($events);
foreach ($events as $key => $count)
    printf("<span style='color: %s;'><nobr>%s (%d)</nobr></span> | ",
        (isset($log_events[$key])?$log_events[$key]['color']:'black'),
        (isset($log_events[$key])?$log_events[$key]['name']:' '.$key),
        $count
    );
?>
</div></table>
<!--           . ,     . -->
: 
<?php
for ($p = 0;$p < count($log)/$rows_per_page;$p++){
    if($p+1 == $curpage) $page_class="class='current'"; else $page_class='';
    printf("<a href=?logfile=%s&page=%d %s>%d</a> | ",$logfile_id,$p+1,$page_class,$p+1);
}
?>
</body>
</html>